/*
	Copyright  2004. Boa Tender Studios. All Rights Reserved.
	This Jscript code may not be reproduced in whole or in part without an express permission of Boa Tender Studios.
*/



//Open, Minimize, Close Skin, Toggle Views

function saveSwitch(key, val)
{
	var value;
	

	if (val == "TRUE")
	{
		value = "turnon";
	}
	else if (val == "FALSE")
	{
		value = "turnoff";
	}
	else if (val) 
	{
		value = "turnon";
	}
	else 
	{
		value = "turnoff";
	}
	
	
	theme.savePreference(key, value);
}

function loadSwitch(key){

	if ("turnon" == theme.loadPreference(key)) 
	{
		return true;
	}
	else 
	{
		return false;
	}
}

function ViewState()
{

	if(loadSwitch("minimizeView"))
	{
		view.minimize();
		saveSwitch("minimizeView", false);
	}
	if(loadSwitch("closeView"))
	{
		view.close();
	}
	if(loadSwitch("plSwitch"))
	{
		toggleView("plView","plWindow");
		saveSwitch("plSwitch", false);
	}
	if(loadSwitch("visSwitch"))
	{
		toggleView("visView","visWindow");
		saveSwitch("visSwitch", false);
	}
	if(loadSwitch("eqSwitch"))
	{
		toggleView("eqView","eqWindow");
		saveSwitch("eqSwitch", false);
	}
	if(loadSwitch("infoSwitch"))
	{
		toggleView("infoView","infoWindow");
		saveSwitch("infoSwitch", false);
	}
}

function toggleView(name,id)
{
	if(loadSwitch(id))
	{
	    saveSwitch(id, false);
		theme.closeView( name );
	} else{
		theme.openView( name );
	}
}

//Close Views

function closeView(id)
{
	saveSwitch(id, false);
	
	if( id=="vidWindow" )
		{
			player.controls.stop();
			saveSwitch("vidWindow",false);
		}
			
	view.close();
}

//Close Skin

function OnCloseSkin()
{
	saveSwitch("closeView", false);
	saveSwitch("vidWindow", false);
}
//Start Skin

function OnStartSkin(){

	if(loadSwitch("plWindow"))
	{
		theme.openView("plView");
	}
	if(loadSwitch("visWindow"))
	{
		theme.openView("visView");
	}
	if(loadSwitch("eqWindow"))
	{
		theme.openView("eqView");
	}
	if(loadSwitch("infoWindow"))
	{
		theme.openView("infoView");
	}
	 
	theme.openView("playerView");
	saveSwitch("closeView",false);
	saveSwitch("vidWindow",false);
	checkVideoView();
}

function onLoadPreview()
{	
	if(player){}
	view.backgroundImage = "";
	view.width = 0;
	view.height = 0;
	theme.currentViewID = "overView";
}

function mainLoad()
{
	volume.value = player.settings.volume;
	updateMetaData("status");
}

//Save Size of Window

function saveViewSize(width,height)
{
	theme.savePreference(width,view.width);
	theme.savePreference(height,view.height);
}

//Size View

function sizeView(width,height)
{
	var viewWidth = theme.loadPreference(width);
	if(viewWidth != "EMPTY"){
		view.width = viewWidth;
	}
	else{
		view.width = view.minWidth;
	}
	var viewHeight = theme.loadPreference (height);
	if(viewHeight != "EMPTY"){
		view.height = viewHeight;
	}
	else{
		view.height = view.minHeight;
	}
}
			

//Metadata text

function updateMetaData(type){

	
	if(type=="status"){
		//if(player.openState!=13) return;
	
		metadata.value = player.status;
	
		if (metadata.value != "--") {
			metadata.value += " - ";
		}
	
		var metaAuthor = player.currentMedia.getItemInfo("author");
		 
	
		if (metaAuthor != "--") {
			metaAuthor += " - ";
		}
	
		metadata.value += metaAuthor;
	
	}else if(type=="playlist"){
		if(player.currentPlaylist.count==0) return;

		var metaAuthor = player.currentMedia.getItemInfo("author");

		if (metaAuthor != "--") {
			metaAuthor += " - ";
		}

		if(player.openState!=13){
			metadata.value = metaAuthor;
		}
	
	else if(type=="start"){
		metadata.value = player.status;
		
		if(metadata.value != "--"){
			metadata.value += " - ";
		}
		
		var metaAuthor = player.currentMedia.getItemInfo("author");
		
		if(metaAuthor != "--"){
			metaAuthor += " - ";
		}
		
		metadata.value += metaAuthor;
		timeEllapsed.value = "test";
	}		
		
	}else{
		metadata.value = player.status;
		metadata.scrolling = (metadata.textWidth > metadata.width);
		return;
	}
	
	//add file name to <Status> - <Author> - <File Name>
	
	metadata.value += player.currentmedia.name;
	
	// when the name is shorter than textbox, don't scroll
	
	metadata.scrolling = (metadata.textWidth > metadata.width);
	
}


//Volume Key Control

function volKey(event)
{
	switch(event.keycode)
	{
		case 39:
		case 38:
			if(player.settings.volume < 95)
			{
				player.settings.volume+=5;
			}else{
				player.settings.volume = 100;
			}
			break;
		case 37:
		case 40:
			if(player.settings.volume > 5)
			{
				player.settings.volume-=5;
			}else{
				player.settings.volume = 0;
			}
			break;
	}
	player.settings.mute = false;
}

//Position Key handler

function positionKey(event)
{
	if(player.openState!=13) return;
	switch(event.keycode)
	{
		case 37:
		case 38:
			if(player.controls.currentPosition > 5)
			{
				player.controls.currentPosition-=5;
			}else{
				player.controls.currentPosition = 0;
			}
			break;
		case 39:
		case 40:
			if(player.controls.currentPosition < player.currentMedia.duration)
			{
				player.controls.currentPosition+=5;
			}else{
				player.controls.currentPosition = player.currentMedia.duration;
			}
			break;
	}
}

//Position Slider Text handler

function updateEllapsedTime ()
{

	if(player.openState!=13) return;

	timeEllapsed.visible = false;
	
	var seekHours = Math.floor((seek.value / 3600));
	if (seekHours < 10) seekHours = "0" + seekHours;

	var seekMinutes = Math.floor((seek.value - (seekHours*3600))/60);
	if (seekMinutes < 10) seekMinutes = "0" + seekMinutes;

	var seekSeconds = Math.floor((seek.value - (seekMinutes*60) - (seekHours*3600)));
	if (seekSeconds < 10) seekSeconds = "0" + seekSeconds;

	var seekString;

	if (seekHours==00)
	{
		seekString = "";
	}
	else
	{
		seekString = seekHours + ":";
	}

	seekString += seekMinutes + ":" + seekSeconds;
	
	timeEllapsedSlider.visible = true;
	timeEllapsedSlider.value = seekString;

}

//Position Slider Text Handler 2

function dragEnd()
{
	timeEllapsedSlider.visible = false;
	timeEllapsed.visible = true;
	
}

//Open file browser

function openFile()
{
	var file = theme.openDialog('FILE_OPEN','FILES_ALLMEDIA');
	if(file)
	{
		player.URL = file;
		player.controls.play();
	}
}

//Playlist

function loadPl()
{
	saveSwitch("plWindow", true);
	
	playlist1.setColumnResizeMode(1, "Stretches");
	playlist1.setColumnResizeMode(2, "AutosizeHeader");
	playlist1.setColumnResizeMode(3, "AutosizeHeader");
	playlist1.setColumnResizeMode(4, "AutosizeHeader");
	playlist1.setColumnResizeMode(5, "AutosizeHeader");
	playlist1.setColumnResizeMode(5, "AutosizeHeader");
	
	checkShuffle();
	sizeView( "plWidth","plHeight" );
}



//Check Shuffle Mode

function savePl()
{
	saveViewSize( "plWidth","plHeight" );
}

function checkShuffle()
{
	if(player.settings.getMode("shuffle")){
		shuffleButton.down = true;
	}
	else{
		shuffleButton.down = false;
	}
	if(player.settings.getMode("loop")){
		loopButton.down = true;
	}
	else{
		loopButton.down = false;
	}
}

//Visualisations

function loadVis()
{
	saveSwitch("visWindow", true);
	sizeView("visWidth","visHeight");
	setVisText();
}

function setVisText()
{
	visEffectText.visible = true;
	visEffectText.value = visEffects.currentEffectTitle + " : " + visEffects.currentPresetTitle;
	visView.timerInterval = 5000;
}

function visTextFade()
{
	visEffectText.visible = false;
	visView.timerInterval = 0;
}

function checkVisualisationsView()
{
	if (player){
		switch (player.playState){
			case 3: 	//playing

				if(player.currentMedia.ImageSourceWidth>0){
					saveSwitch("visWindow",false);
					view.close();
				}
				break;
			}
		}

}

function saveVis()
{
	saveViewSize("visWidth","visHeight");
	mediacenter.effectType = visEffects.currentEffectType;
	mediacenter.effectPreset = visEffects.currentPreset;
}

//Video Mode

function loadVid()
{	
	saveSwitch("vidWindow", true);
	if(theme.loadPreference("slideTab")=="--") {slideReverse=true;}
	else{
		slideReverse = loadSwitch("slideTab");
	}
	
	checkZoomMode();
	updateZoomToolTip();
	slideSettings();
	
}
		

function saveVid()
{
	saveSwitch("slideTab", !slideReverse);
}

function checkVidSize()
{
	if(player.openState!=13) return;
	loadVidSize();
}

function saveVidSize()

{
	theme.savePreference("vidHeight",view.height);
	theme.savePreference("vidWidth",view.width);
	mediacenter.videoZoom = 50;
	zoomButton.upToolTip = zoomTipBase.tooltip;
	saveSwitch("vidSnapMode",false);
}

function loadVidSize()
{
var videoSize = theme.loadPreference("vidWidth");

    if( "--" != videoSize )
    {
        view.width = videoSize;
    }
    else
    {
		view.width = view.minWidth;
	}
    videoSize = theme.loadpreference("vidHeight");

    if( "--" != videoSize )
    {
        view.height = videoSize;
    }
     else
    {
		view.height = view.minHeight;
	}
    
}

function checkVideoState()
{
	if (player){
	
		switch (player.playState)
		
			{
			
			case 3: 	//playing
			
				if(!player.currentMedia.ImageSourceWidth>0)
				{
					saveSwitch("vidWindow", false);
					view.close();
					break;
				}
				vidOuterFrame.visible = true;
				checkZoomMode();
				break;
			case 8:
				return;
				break;
			}
			buttonVidResize.enabled = true;
			fullScreenButton.enabled = true;
			vidPause.visible = false;
			zoomButton.enabled = true;
		}

	if (!player.controls.isAvailable("Stop")) {
		vidOuterFrame.visible = false;
		buttonVidResize.enabled = false;
		fullScreenButton.enabled = false;
		zoomButton.enabled = false;
		view.width = view.minWidth;
		view.height = view.minHeight;
		vidPause.visible = true;
	}
}

function checkVideoView()
{
	if (player){
		switch (player.playState){
			case 3: 	//playing

				if((!loadSwitch("vidWindow")) && player.currentMedia.ImageSourceWidth>0){
					theme.openView("vidView");
				}
				break;
			}
		}

}


function slideSettings()
{
	if(slideReverse==false)
	{
		vidSettingsTab.moveTo(0,view.height-92, 500);
		slideReverse = true;
		settingsButton.down = true;
	}
	
	else
	{
		vidSettingsTab.moveTo(0,view.height-184, 500);
		slideReverse =false;
	}
}

//Video Zoom

function checkZoomMode()
{
	if(theme.loadPreference("vidSnapMode")=="--")saveSwitch("vidSnapMode",false);
	if(loadSwitch("vidSnapMode"))
	{
		snapVid();
	}
	else
	{
		checkVidSize();
	}
}

function vidZoom()
{
	
	if(!loadSwitch("vidSnapMode"))
	{
		mediacenter.videoZoom = 50;
	}
	
	if(mediacenter.videoZoom<51)
	{
		mediacenter.videoZoom = 100;
	}
	else if(mediacenter.videoZoom<101)
	{
		mediacenter.videoZoom = 200;
	}
	else
	{
		mediacenter.videoZoom = 50;
	}
	snapVid();
	updateZoomToolTip();
}

function updateZoomToolTip()
{
	if(!loadSwitch("vidSnapMode"))
	{
		zoomButton.upToolTip = zoomTipBase.toolTip;
	}
	
	if(mediacenter.videoZoom<51)
	{
		zoomButton.upTooltip = "Zoom 100%";
	}
	else if(mediacenter.videoZoom<101)
	{
		zoomButton.upTooltip = "Zoom 200%";
	}
	else if(mediacenter.videoZoom<201)
	{
		zoomButton.upTooltip = "Zoom 50%";
	}
	
}
function snapVid()
{
	saveSwitch("vidSnapMode",true);
	
	var zoom = mediacenter.videoZoom;
	var viewWidth = (player.currentMedia.imageSourceWidth * (zoom/100.00));
	var viewHeight = (player.currentMedia.imageSourceHeight * (zoom/100.00));

	view.width = viewWidth + 70;
	view.height = viewHeight + 152;
}

//Door Open

var frameCount = 0;
var reverse = false;

function toggleDoor()
{	
		
	if (reverse)
		{
			frameCount--;
			doorSub.visible = true;
			doorSub.backgroundImage = "door" + frameCount + ".png";
			view.timerInterval = 75;
			doorButton.enabled = false;
			bgImage.backgroundImage = "pl_main_back.png";
		}
		
	else{
			frameCount++;
			doorSub.visible = true;
			doorSub.backgroundImage = "door" + frameCount + ".png";
			view.timerInterval = 75;
			doorButton.enabled = false;
			bgImage.backgroundImage = "pl_main_back_on.png";
				if(!loadSwitch("switchFan"))
				{
					fan.backgroundImage = "pl_fan_run.gif";
				}
		}
	
	if (frameCount==0){
		reverse = false;
		view.timerInterval = 0;
		frameCount = 0;
		doorSub.backgroundImage = "door1.png"
		doorSub.passThrough = false;
		doorButton.enabled = true;
		fan.backgroundImage = "pl_fan_static.gif";
		}
	
	if (frameCount==29){
		reverse = true;
		view.timerInterval = 0;
		frameCount = 29;
		doorSub.passThrough = true;
		doorSub.visible = false;
		doorButton.enabled = true;
		}
		

}

//Equalizer

function loadEq()
{
	var tension = theme.loadPreference("eqTension");
	eqsettings.splineTension = tension;
	
	saveSwitch("eqWindow", true);
	checkTensionDownStatus();
}

function saveEq()
{
	var tension = eqsettings.splineTension;
	theme.savePreference("eqTension", tension);
}

function toggleFan()
{
	if(loadSwitch("switchFan"))
	{
		saveSwitch("switchFan", false);
	}
	else{
		saveSwitch("switchFan", true);
	}
}

function toggleTension(button)
{
	if(button=="soft")
		{
			eqSoft.down = true;
			eqHard.down = false;
			eqOff.down = false;
			eqsettings.splineTension = 2;
		}
	else if(button=="hard")
		{
			eqHard.down = true;
			eqOff.down = false;
			eqSoft.down = false;
			eqsettings.splineTension = 8;
		}
	else
		{
			eqOff.down = true;
			eqSoft.down = false;
			eqHard.down = false;
			eqsettings.splineTension = 0;
		}
}

function checkTensionDownStatus()
{
	if(eqsettings.splineTension==0) 
	{
		eqOff.down = true;
	}
	if(eqsettings.splineTension>0 && eqsettings.splineTension<=2) 
	{
		eqSoft.down = true;
	}
	if(eqsettings.splineTension>2) 
	{
		eqHard.down = true;
	}
}

function toggleBox()
{
	if(eqsettings.speakerSize==2)
	{
		eqsettings.speakerSize = -1;
	}
	eqsettings.speakerSize++;

}

//Info Mode

var back;
var	navi;
var	mode;
var infoMode;
var startUp = 0;
var infoSwitch;
var limit;
var orderNr;
var orderReverse;
var startOrder;
var toggleOn = false;
var buttonToggle = false;


function loadInfo()
{
	saveSwitch("infoWindow", true);
	back = true;
	navi = false;
	mode = 1;
	orderNr = 1;
	orderReverse=false;
	infoSwitch = true;
	startOrder = true;
}

function saveInfo()
{
}

var infoFrameCount = 0;
var infoReverse = false;

function toggleInfo()
{
	if (infoReverse)
		{
			infoFrameCount--;
			infoScreen.visible = true;
			infoScreen.backgroundImage = "info" + infoFrameCount + ".png";
			view.timerInterval = 50;
			infoButton.enabled = false;
			infoMenuBack.visible = false;
			infoMenu.visible = false;
			infoDisplay.visible = false;
		}
		
	else{
			infoFrameCount++;
			infoScreen.visible = true;
			infoScreen.backgroundImage = "info" + infoFrameCount + ".png";
			view.timerInterval = 50;
			infoButton.enabled = false;
		}
		
	if (infoFrameCount==25)
		{
			infoReverse = true;
			view.timerInterval = 0;
			infoFrameCount=25;
			infoScreen.backgroundImage = "info25.png";
			infoButton.upToolTip = "Hide Info Mode";
			infoButton.enabled = true;
			toggleOn=true;
			toggleMenu();
			infoButton.upToolTip = "Hide Info Screen"
		}
	
	if (infoFrameCount==0)
		{
			infoReverse = false;
			view.timerInterval = 0;
			infoFrameCount=0;
			infoScreen.backgroundImage = "spacer.png";
			infoButton.upToolTip = "Show Info Mode";
			infoButton.enabled = true;
			startUp=0;
			infoButton.upToolTip = "Show Info Screen"
		}
}

function showInfo(infoMode)
{
	
	switch(infoMode)
	{
		case 1:
			back = true;
			navi = false;
			mode = 1;
			infoSwitch=true;
			checkContent();
		break;
		case 2:
			back = false;
			navi = true;
			mode = 2;
			infoSwitch=true;
			checkContent();
		break;
		case 3:
			back = false;
			navi = true;
			mode = 3;
			infoSwitch=true;
			checkContent();
		break;
	}
}

function switchOrder()
{
	if(orderReverse==false){orderNr++;}
	else{orderNr--;}
}
var url

function checkContent()
{

	
	switch(mode)
	{
		case 1:
				infoMenuBack.visible = back;
				url = "info_menu_bg.png";
				limit = 1;
				if(infoSwitch==true&&startUp!=0) {nextImg();}
				infoMenu.visible = navi;
				email.visible = false;
		break;
		case 2:
				infoMenuBack.visible = back;
				infoMenu.visible = navi;
				infoReturn.enabled = false;
				email.visible = true;
				limit = 1;
				url = "info_menu_contacts.png";
				if(infoSwitch==true&&startUp!=0) {nextImg();}
		break;
		case 3:
				if(startOrder==false)switchOrder();
				if(orderNr==12)orderNr=1;
				if(orderNr<1)orderNr=11;
				infoMenuBack.visible = back;
				infoMenu.visible = navi;
				limit = 12;
				url = "infomkg_"+orderNr+".png";
				if(infoSwitch==true&&startUp!=0) {nextImg();}
		break;
	}
}

function nextImg()
{
	infoDisplay.backgroundImage = url;
	infoDisplay.alphaBlend = 75;
	checkNavi();
}

function checkNavi()
{
	if(limit==1)
	{
		infoNext.enabled = false;
		infoPrev.enabled = false;
	}
	else
	{
		infoNext.enabled = false;
		infoPrev.enabled = false;
		infoReturn.enabled = false;
	}
	infoDisplay.alphaBlendTo(255,500);
	infoSwitch = false;
	startUp = 0;
}

function toggleMenu()
{
	if (toggleOn==true)
	{
		infoDisplay.visible = true;
		infoDisplay.alphaBlendTo(255,300);
		toggleOn=false;
	}
	else
	{
		infoDisplay.alphaBlendTo(0,300);
		infoMenuBack.visible = false;
		infoMenu.visible = false;
		buttonToggle = true;
	}
}


function endAlphaBlend()
{
	
	if(buttonToggle==true)
	{
		toggleInfo();
		buttonToggle=false;
	}
	else {
		if(infoSwitch==true){checkContent();}
		infoMenuBack.enabled = true;
		infoMenu.enabled = true;
		if(mode==3)
			{
				infoNext.enabled = true;
				infoPrev.enabled = true;
			}
		infoReturn.enabled = true;
		startUp = 1;
	}
	
}